#include<conio.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<io.h>
#include<dos.h>
#include<allegro.h>
#include<libcda.h>
#include"scumm16.h"

long flip(long n){
  return((unsigned long)((unsigned char *)&n)[0]<<24|
  ((unsigned char *)&n)[1]<<16|((unsigned char *)&n)[2]<<8|
  ((unsigned char *)&n)[3]);
}

#define MAX_BACK 5*320

#define SPAN ITAL
#define HEBR 7

#define COSTUME 2
#define ROOM 4
#define SCRIPT 5
#define SOUND 6
#define FONT 10
#define DIGI 11

#define MM_OLD 1
#define ZAK_OLD 2
#define MM_ZAK_NEW 3
#define LOOM_INDY_OLD 4
#define MONK_EGA 5
#define INDY_256 6
#define MONK_VGA 7
#define MONKEY2 8
#define SAMNMAX 9
#define COMI 10

#define MNU_BOX 0
#define MNU_PAL 1
#define MNU_MSK 2

#define NUM_DLG 10
#define DLG_CLEAR 0
#define DLG_MENU 1
#define DLG_SCRIPT 2
#define DLG_GRAPHIC 3
#define DLG_SLIDER 4
#define DLG_LIST 5
#define DLG_OBJECT 6
#define DLG_OBJLIST 7
#define DLG_INFOBACK 8
#define DLG_INFOTEXT 9

char *oldhead[] = {NULL,NULL,"CO",NULL,"RO","SC","SO",NULL,NULL,NULL,"C\1",NULL};
char *mi2head[] = {NULL,NULL,"COST",NULL,"ROOM","SCRP","SOUN",NULL,NULL,NULL,"CHAR",NULL};

PALETTE vga_pal;
RGB ega_pal[32] = {
  {0,0,0}, {0,0,42}, {0,42,0}, {0,42,42}, {42,0,0}, {42,0,42}, {42,21,0},
  {42,42,42}, {21,21,21}, {21,21,63}, {21,63,21}, {21,63,63}, {63,21,21},
  {63,21,63}, {63,63,21}, {63,63,63},

  {0,0,0}, {63,63,63}, {51,0,0}, {0,63,51}, {63,0,63}, {0,51,0}, {0,0,51},
  {63,63,0}, {63,34,0}, {34,17,0}, {63, 34, 34}, {17,17,17}, {34,34,34},
  {34,63,34}, {34,34,63}, {51,51,51}};

unsigned char lucas_crypt=0xff;
unsigned char old_crypt=0xff;
unsigned short resource_count;
struct resource{
  char name[80];
  char type;
  unsigned short room;
  unsigned int offset;
  unsigned char number;
} resource_list[256*4];
char scr_text[65536];
short resource_current=-1;
short object_current=0;
FILE *fin,*fout;
DATAFILE *data;
int finder;
char towns=0;
char game_name[80];
char temp_dir[80],game_dir[80],file[80];
char info_text[80];
char obj_text[80];
char pre[2];
char version,oldversion;
char roomnames[100][10];
char lang=COMM;
unsigned char trans_color;
unsigned int numscripts,numsounds,numcostumes,numrooms,numfonts,numdigis;
unsigned char costumes[256*4],scripts[256*4],sounds[256*4],rooms[256*4];
unsigned short fonts[256*4];
unsigned short check,numobjects;
unsigned long costoff[256*4],scroff[256*4],sndoff[256*4],fontoff[256*4],digioff[256*4];
unsigned long objects[256*5];
long fsize;
unsigned char c64table[16]={0,15,4,3,5,2,1,14,12,6,12,8,7,10,9,8};
unsigned char charmap[256*8],picmap[4096],colormap[4096],objmap[2048],maskmap[4096],maskchar[4096];
unsigned char colors[4];
struct _finddata_t fileinfo;
BITMAP *background, *objpict, *pcx;
unsigned short picwidth,picheight;
unsigned long picoff,mskoff;
typedef int polygons[8];
polygons walkbox[256];
unsigned int walkcolor[256];
unsigned int numboxes,numobjs;
unsigned short boxoff;
struct laobj{
  char name[80];
  unsigned short number,images,x,y,width,height;
  unsigned long gfxoff[2],infoff,mskoff;
}objs[256];
DIALOG_PLAYER *player;
unsigned short draw_flags;
void (*load_table)();
int (*load_room)(int r);
int walk_box();
int c64_pal();
int show_mask();
int set_mspeed();
int load_proc();
int save_background();
int save_object();
int quit_proc();
int objupdate(void *dp3, int d2);
int my_list_proc(int msg, DIALOG *d, int c);
char *list_getter(int, int *);
int obj_list_proc(int msg, DIALOG *d, int c);
char *obj_getter(int, int *);
int my_bitmap_proc(int msg, DIALOG *d, int c);
int set_lang();
unsigned short *LangTable;
long tsize=0;

MENU file_menu[] =
{
   { "&Load Lucasarts File",     load_proc,        NULL},
   { "Save &Background Image",   save_background,  NULL},
   { "Save &Object Image",       save_object,      NULL},
   { "&Quit",                    quit_proc,        NULL},
   { NULL,                       NULL,             NULL}
};

MENU options_menu[] =
{
   { "Show &Walking Boxes",      walk_box,         NULL, D_DISABLED},
   { "&C64 Palette",             c64_pal,          NULL, D_DISABLED},
   { "Show &Mask",               show_mask,        NULL, D_DISABLED},
   { "&Set Mouse Speed",         set_mspeed,       NULL},
   { NULL,                       NULL,             NULL}
};

MENU lang_menu[] =
{
   { "&Common",                 set_lang,       NULL, D_SELECTED,       (void *)COMM},
   { "&Japanese",               set_lang,       NULL, 0,                (void *)SJIS},
   { "&Hebrew",                 set_lang,       NULL, 0,                (void *)HEBR},
   { "&Spanish",                set_lang,       NULL, 0,                (void *)SPAN},
   { "&Italian",                set_lang,       NULL, 0,                (void *)ITAL},
   { "&German",                 set_lang,       NULL, 0,                (void *)GERM},
   { "&French",                 set_lang,       NULL, 0,                (void *)FREN},
   { NULL,                      NULL,           NULL}
};

MENU about_menu[] =
{
   { "SCUMM16 v.5b",           NULL,             NULL},
   { "by Kevin Carnes",          NULL,             NULL},
   { "carnes@lclark.edu",        NULL,             NULL},
   { NULL,                       NULL,             NULL}
};

MENU menu[] =
{
   { "&File",                    NULL,             file_menu},
   { "&Options",                 NULL,             options_menu},
   { "&Game Language",           NULL,             lang_menu},
   { "&About",                   NULL,             about_menu},
   { NULL,                       NULL,             NULL }
};

DIALOG main_screen[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)   (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_clear_proc,      0,    0,    0,    0,    0,  254,    0,    0,       0,    0,    NULL},
   { d_menu_proc,       0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    menu},
   { d_textbox_proc,  432,   50,  320,  200,    0,  254,    0,    D_SELECTED|D_HIDDEN,0,  0,    scr_text},
   { my_bitmap_proc,  432,   50,  320,  200,    0,  254,    0,    0,       0,    0,    NULL},
   { d_slider_proc,   442,  258,  300,   30,    0,  254,    0,    D_HIDDEN,640,  0,    NULL, NULL},
   { my_list_proc,     52,   50,  304,  200,    0,  255,    0,    0,       0,    0,    list_getter},
   { d_bitmap_proc,   432,  300,  320,  200,    0,  254,    0,    0,       0,    0,    NULL},
   { obj_list_proc,    52,  300,  304,  200,    0,  255,    0,    D_HIDDEN,0,    0,    obj_getter},
   { d_box_proc,       30,   24,  740,   14,    0,   15,    0,    0,       100,  0,    NULL},
   { d_text_proc,      33,   27,  736,    8,    0,   15,    0,    0,       0,    0,    info_text},
   { NULL,              0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL}
};

char xspeed[2]="2", yspeed[2]="2";

DIALOG mouse_speed[] =
{
   { d_box_proc,        0,    0,  200,  100,    0,  254,    0,    0,       0,    0,    NULL},
   { d_text_proc,       0,    0,    0,    0,    0,  254,    0,    0,       0,    0,    "Mouse X Speed:"},
   { d_edit_proc,       0,    0,    0,    0,    0,  254,    0,    0,       1,    0,    xspeed},
   { d_text_proc,       0,    0,    0,    0,    0,  254,    0,    0,       0,    0,    "Mouse Y Speed:"},
   { d_edit_proc,       0,    0,    0,    0,    0,  254,    0,    0,       1,    0,    yspeed},
   { d_button_proc,     0,    0,    0,    0,    0,  254,    0,    D_EXIT,  0,    0,    "OK"},
   { NULL,              0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL}
};

char roomcol1[2]="0",roomcol2[2]="0";

DIALOG room_col[] =
{
   { d_box_proc,        0,    0,  200,  100,    0,  254,    0,    0,       0,    0,    NULL},
   { d_text_proc,       0,    0,    0,    0,    0,  254,    0,    0,       0,    0,    "Room Color 1 (0-F): "},
   { d_edit_proc,       0,    0,    0,    0,    0,  254,    0,    0,       1,    0,    roomcol1},
   { d_text_proc,       0,    0,    0,    0,    0,  254,    0,    0,       0,    0,    "Room Color 2 (0-F): "},
   { d_edit_proc,       0,    0,    0,    0,    0,  254,    0,    0,       1,    0,    roomcol2},
   { d_button_proc,     0,    0,    0,    0,    0,  254,    0,    D_EXIT,  0,    0,    "OK"},
   { NULL,              0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL}
};

int set_lang(){
  int x;
  for(x=0;lang_menu[x].text;x++) lang_menu[x].flags&=~D_SELECTED;
  active_menu[0].flags|=D_SELECTED;
  for(x=0;lang_menu[x].text;x++)
    if(lang_menu[x].flags&D_SELECTED)
      lang=(int)lang_menu[x].dp;
  return(0);
}

unsigned char lucas_read_char(FILE *f){
  unsigned char c;
  if(!f) return(0);
  fread((char *)&c,1,1,f);
  c^=lucas_crypt;
  return c;
}

unsigned short lucas_read_int(FILE *f){
  unsigned short s;
  if(!f) return(0);
  fread((char *)&s,2,1,f);
  s^=(lucas_crypt*256+lucas_crypt);
  return(s);
}

unsigned long lucas_read_long(FILE *f){
  unsigned long i;
  if(!f) return(0);
  fread((char *)&i,4,1,f);
  i^=(lucas_crypt*256*256*256+lucas_crypt*256*256+lucas_crypt*256+lucas_crypt);
  return(i);
}

void lucas_read_head(FILE *f, char *s, int n){
  int x;
  for(x=0;x<n;x++)
    s[x]=lucas_read_char(f);
  s[x]=0;
}

void lucas_pixel(BITMAP *b, int x, int y, int color){
  if(version<INDY_256)
    putpixel(b,x,y,makecol(ega_pal[color].r*4,ega_pal[color].g*4,ega_pal[color].b*4));
  else
    putpixel(b,x,y,makecol(vga_pal[color].r,vga_pal[color].g,vga_pal[color].b));
}

char *LangToUni(unsigned char *i){
  static unsigned short t[80];
  char j=0,n=0;
  int x;
  unsigned short s;
  if(lang==HEBR){
    for(x=0;x<strlen(i);x++)
      if(i[x]&0x80) t[x]=i[x]+0x550;
        else t[x]=i[x];
    t[x]=0;
  }
  else{
    LangTable=data[lang].dat;
    tsize=data[lang].size/sizeof(short);
    while(n<strlen(i)){
      s=i[n++];
      if((s&0x80)&&(lang==SJIS)){
        s=i[n++]|s<<8;
      }
      for(x=0;(x<tsize)&&(LangTable[x]!=s);x+=2);
      if(x<tsize) t[j++]=LangTable[x+1];
      else t[j++]=s;
    }
    t[j]=0;
  }
  return((char *)&t[0]);
}

FILE *open_room(unsigned int n){
  FILE *f;
  if(version>=MONKEY2){
    sprintf(file,"%s%s.%c%c%u",game_dir,game_name,pre[0],pre[1],rooms[n]);
  }
  else if((version<MONK_EGA)||(version==INDY_256)){
    sprintf(file,"%s%.2u.LFL",game_dir,n);
  }
  else{
    sprintf(file,"%sDISK%.2u.LEC",game_dir,rooms[n]);
  }
  f=fopen(file,"rb");
  return(f);
}

int check_room(unsigned int n){
  FILE *f;
  int r=0;
  if(version>=MONKEY2){
    sprintf(file,"%s%s.%c%c%u",game_dir,game_name,pre[0],pre[1],rooms[n]);
  }
  else if((version<MONK_EGA)||(version==INDY_256)){
    if(n>=98) return(0);
    sprintf(file,"%s%.2u.LFL",game_dir,n);
  }
  else{
    sprintf(file,"%sDISK%.2u.LEC",game_dir,rooms[n]);
  }
  if(finder=_findfirst(file,&fileinfo)!=-1){
    r=1;
    _findclose(finder);
  }
  return(r);
}

void update_draw(int i){
  draw_flags|=1<<i;
}

void draw_draw(){
  unsigned short s;
  show_mouse(NULL);
  for(s=0;s<NUM_DLG;s++){
    if((main_screen[s].flags&D_HIDDEN)&&(s!=DLG_SCRIPT)){
      rectfill(screen,main_screen[s].x,main_screen[s].y,
        main_screen[s].x+main_screen[s].w,
        main_screen[s].y+main_screen[s].h,
        main_screen[0].bg);
    }
    else if(draw_flags&(1<<s)){
      SEND_MESSAGE(&main_screen[s],MSG_DRAW,0);
      draw_flags^=(1<<s);
    }
  }
  show_mouse(screen);
}

void vga_decode(FILE *data,BITMAP *b,int width,int height){
int x,y,z,p,q;
unsigned char c,strip,color,bits,run,sub,horiz;
unsigned long off,donde;
unsigned int buffer, mask;

void putpix(void){
  if((color!=trans_color)||(version==MONK_VGA))
    lucas_pixel(b,x,y,color);
  if(horiz){
    x++;
    if(x>=strip*8+8){
      x=strip*8;
      y++;
    }
  }
  else{
    y++;
    if(y>=height){
      y=0;
      x++;
    }
  }
}

int check(void){
  if(horiz){
    return(y<height);
  }
  else{
    return(x<strip*8+8);
  }
}

int getbit(void)
{
  if ((mask <<= 1) == 256){
    buffer = lucas_read_char(data);  mask = 1;
  }
  return ((buffer & mask) != 0);
}

  donde=ftell(data);
  for(strip=0;strip<(width/8);strip++){
    mask=128;
    if(version==MONK_VGA) fseek(data,donde+4+strip*4,SEEK_SET);
    else fseek(data,donde+8+strip*4,SEEK_SET);
    off=lucas_read_long(data);
    fseek(data,donde+off,SEEK_SET);
    c=lucas_read_char(data);
    switch(c/0xA){
      case 0:
        horiz=1;
        y=0;
        x=strip*8;
        while(check()){
          color=lucas_read_char(data);
          putpix();
        }
      break;
      case 1:
      case 2:
      case 3:
      case 4:
        horiz=1-((c/0xa)&1);
        sub=1;
        x=strip*8;
        y=0;
        bits=c%0xA;
        color=lucas_read_char(data);
        putpix();
        while(check()){
          for(z=0;z<3;z++){
            if(!getbit()) break;
          }
          switch(z){
            case 0:
              putpix();
            break;
            case 1:
              color=0;
              for(p=0;p<bits;p++){
                color=color+(getbit()<<p);
              }
              sub=1;
              putpix();
            break;
            case 2:
              color-=sub;
              putpix();
            break;
            case 3:
              sub=-sub;
              color-=sub;
              putpix();
            break;
          }
        }
      break;
      default:
        horiz=1;
        sub=1;
        x=strip*8;
        y=0;
        bits=c%0xA;
        color=lucas_read_char(data);
        putpix();
        while(check()){
          for(z=0;z<2;z++){
            if(!getbit()) break;
          }
          switch(z){
            case 0:
              putpix();
            break;
            case 1:
              color=0;
              for(p=0;p<bits;p++){
                color=color+(getbit()<<p);
              }
              sub=1;
              putpix();
            break;
            case 2:
              p=(getbit()<<0);
              p=p+(getbit()<<1);
              p=p+(getbit()<<2);
              if(p<4){
                color-=4-p;
                putpix();
              }
              else if(p==4){
                run=0;
                for(q=0;q<8;q++){
                  run=run+(getbit()<<q);
                }
                for(q=0;q<run;q++){
                  putpix();
                }
              }
              else{
                color+=p-4;
                putpix();
              }
            break;
          }
        }
      break;
    }
  }
}


void indy_decode(FILE *data,BITMAP *b,int width,int height){
  unsigned char indy_colors[256];
  int x,y,z,p,q;
  unsigned char color,c,strip,numcolors,bits,run,sub,horiz;
  unsigned long off,kang;
  unsigned int buffer, mask;

  int getbit(int s)
  {
    static unsigned int buffer, mask;
    if(s!=-1){
      mask=s; 
      return(-1);
    }
    if ((mask <<= 1) == 256){
      buffer = lucas_read_char(data);  mask = 1;
    }
    return ((buffer & mask) != 0);
  }
  kang=ftell(data);
  for(strip=0;strip<(width/8);strip++){
    fseek(data,kang+4+strip*4,SEEK_SET);
    off=lucas_read_long(data);
    fseek(data,kang+off,SEEK_SET);
    sub=lucas_read_char(data);
    if(sub==1){
      for(x=0;x<8;x++){
        for(y=0;y<height;y++){
          lucas_pixel(b,strip*8+x,y,lucas_read_char(data));
        }
      }
    }
    else if(sub==2){
      x=0;
      y=0;
      while(x<8){
        p=lucas_read_char(data);
        color=lucas_read_char(data);
        for(z=0;z<p+1;z++){
          lucas_pixel(b,strip*8+x,y,color);
          y++;
          if(y>=height){
            y=0;
            x++;
          }
        }
      }
    }
    if(sub==3){
      x=0;
      y=0;
      run=0;
      getbit(128);
      while(x<8){
        c=0;
        for(z=0;z<4;z++){
          c+=getbit(-1)<<z;
        }
        switch(c>>2){
          case 0:
            color=0;
            for(z=0;z<4;z++){
              color+=getbit(-1)<<z;
            }
            for(z=0;z<((c&3)+2);z++){
              lucas_pixel(b,strip*8+x,y,run*16+color);
              y++;
              if(y>=height){
                y=0;
                x++;
              }
            }
          break;
          case 1:
            for(p=0;p<(c&3)+1;p++)
            {
              color=0;
              for(z=0;z<4;z++){
                color+=getbit(-1)<<z;
              }
              lucas_pixel(b,strip*8+x,y,run*16+color);
              y++;
              if(y>=height){
                y=0;
                x++;
              }
            }
          break;
          case 2:
              run=0;
              for(z=0;z<4;z++){
                run+=getbit(-1)<<z;
              }
          break;
        }
      }
    }
    if(sub==4){
      numcolors=lucas_read_char(data);
      for(x=0;x<numcolors;x++){
        indy_colors[x]=lucas_read_char(data);
      }
      x=0;
      y=0;
      while(x<8){
        c=lucas_read_char(data);
        if(c<numcolors){
          lucas_pixel(b,strip*8+x,y,indy_colors[c]);
          y++;
          if(y>=height){
            y=0;
            x++;
          }
        }
        else{
          run=c-numcolors+1;
          c=lucas_read_char(data);
          for(z=0;z<run;z++){
            lucas_pixel(b,strip*8+x,y,c);
            y++;
            if(y>=height){
              y=0;
              x++;
            }
          }  
        }
      }
    }
    else if(sub==7){
      getbit(128);
      bits=sub+1;
      sub=1;
      x=0;
      y=0;
      color=lucas_read_char(data);
      lucas_pixel(b,strip*8+x,y,color);
      y++;
      if(y>=height){
        y=0;
        x++;
      }
      while(x<8){
        for(z=0;z<3;z++){
          if(!getbit(-1)) break;
        }
        switch(z){
          case 0:
            lucas_pixel(b,strip*8+x,y,color);
            y++;
            if(y>=height){
              y=0;
              x++;
            }
          break;
          case 3:
            color=0;
            for(p=0;p<bits;p++){
              color=color+(getbit(-1)<<p);
            }
            sub=1;
            lucas_pixel(b,strip*8+x,y,color);
            y++;
            if(y>=height){
              y=0;
              x++;
            }
          break;
          case 2:
            color-=sub;
            lucas_pixel(b,strip*8+x,y,color);
            y++;
            if(y>=height){
              y=0;
              x++;
            }
          break;
          case 1:
            sub=-sub;
            color-=sub;
            lucas_pixel(b,strip*8+x,y,color);
            y++;
            if(y>=height){
              y=0;
              x++;
            }
          break;
        }
      }
    }
  }
}

void new_mask(FILE *data,int off,BITMAP *b,int width,int height){
  int x,y,z,m,n=0;
  unsigned char color,run,done;
  char head[5];
  long kang,size;
  if(version>=MONKEY2) fseek(data,off+4,SEEK_SET);
  do{
  if(version>=MONKEY2){
    size=flip(lucas_read_long(data));
    if(size<width/8) return;
  }
  x=y=0;
  drawing_mode(DRAW_MODE_XOR,b,0,0);
  while(x<width){
    fseek(data,off+(x/8)*2,SEEK_SET);
    if(version>=MONKEY2) fseek(data,8,SEEK_CUR);
    else if((version>INDY_256)||(version==MONK_EGA)) fseek(data,2,SEEK_CUR);
    else if(version==INDY_256) fseek(data,4,SEEK_CUR);
    kang=lucas_read_int(data);
    fseek(data,off+kang,SEEK_SET);
    done=0;
    if(kang==0) rectfill(b,x,0,x+width-1,height-1,0);
    else while(!done){
      color=lucas_read_char(data);
      if(color<0x80){
        run=color;
        if(run==0){
          run=lucas_read_char(data);
        }
        for(z=0;z<run;z++){
          color=lucas_read_char(data);
          for(m=0;m<8;m++){        
            lucas_pixel(b,x+m,y,((color>>(7-m))&1)<<n);
          }
          y++;
          if(y==height) done=1;
        }
      }
     else{
       run=color&0x7f;
       if(run==0){
         run=lucas_read_char(data);
        }
        color=lucas_read_char(data);
        for(z=0;z<run;z++){
          for(m=0;m<8;m++){
            lucas_pixel(b,x+m,y,((color>>(7-m))&1)<<n);
          }
          y++;
          if(y==height) done=1;
        }
      }
    }
    y=0;
    x+=8;
  }
  if(version>=MONKEY2){
    fseek(data,off+size,SEEK_SET);
    lucas_read_head(data,head,4);
    off=ftell(data)-4;
    n++;
  }
  }while((version>=MONKEY2)&&(strncmp(head,"ZP",2)==0));
  drawing_mode(DRAW_MODE_SOLID,b,0,0);
}

void ega_decode(FILE *data,BITMAP *b,int width,int height){
  int x,y,z;
  unsigned char color,run;
  lucas_read_int(data);
  z=lucas_read_int(data);
  fseek(data,z-4,SEEK_CUR);
  x=y=0;
  while(x<width){
    color=lucas_read_char(data);
    if(color>=0x80){
      run=color&0x3f;
      if(color&0x40){
        color=lucas_read_char(data);
        if(run==0){
          run=lucas_read_char(data);
        }
        for(z=0;z<run;z++){
          if(z&1){
            lucas_pixel(b,x,y,color&0xf);
          }
          else{
            lucas_pixel(b,x,y,color>>4);
          }
          y++;
          if(y>=height){
            y=0;
            x++;
          }
        }
      }
      else{
        if(run==0){
          run=lucas_read_char(data);
        }
        for(z=0;z<run;z++){
          putpixel(b,x,y,getpixel(b,x-1,y));
          y++;
          if(y>=height){
            y=0;
            x++;
          }
        }            
      }
    }
    else if(color<0x80){
      run=color>>4;
      if(run==0){
        run=lucas_read_char(data);
      }
      for(z=0;z<run;z++){
        lucas_pixel(b,x,y,color&0xf);
        y++;
        if(y>=height){
          y=0;
          x++;
        }
      }
    }
  }
}

void ladecode(FILE *data,BITMAP *b,int width,int height){
  int x,y,z;
  unsigned char color,run;
  x=y=0;
  while(x<width){
    color=lucas_read_char(data);
    if(color<0x80){
      run=color >> 4;
      color=color&0xf;
      if(run==0){
        run=lucas_read_char(data);
      }
      for(z=0;z<run;z++){
        lucas_pixel(b,x,y,color);
        y++;
        if(y>=height){
          y=0;
          x++;
        }
      }
    }
    if(color>=0x80){
      run=color&0x7f;
      if(run==0){
        run=lucas_read_char(data);
      }
      for(z=0;z<run;z++){
        putpixel(b,x,y,getpixel(b,x-1,y));
        y++;
        if (y>=height){
          y=0;
          x++;
        }
      }
    }
  }
}

void lamask(FILE *data,int off,BITMAP *b,int width,int height){
  int x,y,z,m;
  unsigned char color,run;
  fseek(data,off,SEEK_SET);
  x=y=0;
  while(x<width){
    color=lucas_read_char(data);
    if(color<0x80){
      run=color;
      if(run==0){
        run=lucas_read_char(data);
      }
      for(z=0;z<run;z++){
        color=lucas_read_char(data);
        for(m=0;m<8;m++){        
          lucas_pixel(b,x+m,y,(color>>(7-m))&1);
        }
        y++;
        if(y==height){
          y=0;
          x+=8;
        }
      }
    }
    else{
      run=color&0x7f;
      if(run==0){
        run=lucas_read_char(data);
      }
      color=lucas_read_char(data);
      for(z=0;z<run;z++){
        for(m=0;m<8;m++){
          lucas_pixel(b,x+m,y,(color>>(7-m))&1);
        }
        y++;
        if(y==height){
          y=0;
          x+=8;
        }
      }
    }
  }
}

void old_decode(FILE *data, unsigned char *map, unsigned int size){
  int x,y,z;
  unsigned color,run;
  unsigned char common[4];
  for(z=0;z<4;z++){
    common[z]=lucas_read_char(data);
  }
  x=0;
  while(x<size){
    color=lucas_read_char(data);
    if (color < 0x40) {
      for (z=0; z<=color; z++) {
        map[x++]=lucas_read_char(data);
      }
    }
    else if (color < 0x80) {
      color &= 0x3F;
      run=lucas_read_char(data);
      for (z=0; z<=color; z++) {
        map[x++] = run;
      }
    }
    else{
      run=common[(color>>5)&3];
      color &= 0x1F;
      for (z=0; z<=color; z++) {
        map[x++] = run;
      }
    }
  }
}

void old_back(FILE *data,BITMAP *b,int width,int height){
  unsigned int x,y;
  int i,j;
  for(x=0;x<width;x++){
    for(y=0;y<height;y++){
      colors[3]=(colormap[y+x*height] & 7);
      for(i=0;i<8;i++){
        for(j=7;j>=0;j--){
          if(options_menu[MNU_PAL].flags&D_SELECTED){
            lucas_pixel(b,(7-j)+x*8,y*8+i,colors[((charmap[picmap[y+x*height]*8+i] >> (j&6)) & 3)]+16);
          }
          else{                                                                                     
            lucas_pixel(b,(7-j)+x*8,y*8+i,c64table[colors[((charmap[picmap[y+x*height]*8+i] >> (j&6)) & 3)]]);
          }
        }
      }
    }
  }
}

void old_mask(FILE *data,BITMAP *b,int width,int height){
  unsigned int x,y;
  int i,j;
  unsigned color,run;
  for(x=0;x<width;x++){
    for(y=0;y<height;y++){
      for(i=0;i<8;i++){
        for(j=7;j>=0;j--){
          if(options_menu[MNU_PAL].flags&D_SELECTED){
            lucas_pixel(b,(7-j)+x*8,y*8+i,((maskchar[maskmap[y+x*height]*8+i] >> (j&6)) & 3)+16);
          }
          else{                                                                                     
            lucas_pixel(b,(7-j)+x*8,y*8+i,c64table[((maskchar[maskmap[y+x*height]*8+i] >> (j&6)) & 3)]);
          }
        }
      }
    }
  }
}

void old_obj(FILE *data,BITMAP *b,int width,int height){
  unsigned int x,y;
  int i,j;
  old_decode(data,objmap,width*height*3);
  for(x=0;x<width;x++){
    for(y=0;y<height;y++){
      colors[3]=(objmap[y*width+x+(width*height)] & 7);
      for(i=0;i<8;i++){
        for(j=7;j>=0;j--){
          if(options_menu[MNU_PAL].flags&D_SELECTED){
            lucas_pixel(b,(7-j)+x*8,y*8+i,colors[((charmap[objmap[y*width+x]*8+i] >> (j&6)) & 3)]+16);
          }
          else{
            lucas_pixel(b,(7-j)+x*8,y*8+i,c64table[colors[((charmap[objmap[y*width+x]*8+i] >> (j&6)) & 3)]]);
          }
        }
      }
    }
  }
  if(options_menu[MNU_MSK].flags&D_SELECTED){
    for(x=0;x<width;x++){
      for(y=0;y<height;y++){
        for(i=0;i<8;i++){
          for(j=7;j>=0;j--){
            if(options_menu[MNU_PAL].flags&D_SELECTED){
              lucas_pixel(b,(7-j)+x*8,y*8+i,((maskchar[objmap[width*height*2+y*width+x]*8+i] >> (j&6)) & 3)+16);
            }
            else{                                                                                     
              lucas_pixel(b,(7-j)+x*8,y*8+i,c64table[((maskchar[objmap[width*height*2+y*width+x]*8+i] >> (j&6)) & 3)]);
            }
          }
        }
      }
    }
  }
}

void draw_room(){
  unsigned int z;
  fin=open_room(resource_list[resource_current].number);
  if(!fin){
    alert("File","not found!","","OK",NULL,0,0);
    return;
  }
  fseek(fin,picoff,SEEK_SET);
  clear_to_color(background,main_screen[DLG_GRAPHIC].bg);
  main_screen[DLG_GRAPHIC].flags&=~D_HIDDEN;
  if((version==MM_OLD)||(version==ZAK_OLD)){
    if(options_menu[MNU_MSK].flags&D_SELECTED){
      old_mask(fin,background,picwidth>>3,picheight>>3);
    }
    else{
      old_back(fin,background,picwidth>>3,picheight>>3);
    }
  }
  else if(version==MM_ZAK_NEW){
    if(options_menu[MNU_MSK].flags&D_SELECTED){
      lamask(fin,mskoff,background,picwidth,picheight);
    }
    else{
      ladecode(fin,background,picwidth,picheight);
    }
  }
  else if(version==LOOM_INDY_OLD){
    if(options_menu[MNU_MSK].flags&D_SELECTED){
      if (mskoff!=-1) new_mask(fin,mskoff,background,picwidth,picheight);
    }
    else{
      ega_decode(fin,background,picwidth,picheight);
    }
  }
  else if(version==MONK_EGA){
    if(options_menu[MNU_MSK].flags&D_SELECTED){
      if (mskoff!=-1) new_mask(fin,mskoff,background,picwidth,picheight);
    }
    else ega_decode(fin,background,picwidth,picheight);
  }
  else if(version==INDY_256){
    if(options_menu[MNU_MSK].flags&D_SELECTED){
      if (mskoff!=-1) new_mask(fin,mskoff,background,picwidth,picheight);
    }
    else{
      indy_decode(fin,background,picwidth,picheight);
    }
  }
  else if((version>=MONKEY2)||(version==MONK_VGA)){
    if(options_menu[MNU_MSK].flags&D_SELECTED){
      if (mskoff!=-1) new_mask(fin,mskoff,background,picwidth,picheight);
    }
    else{
      vga_decode(fin,background,picwidth,picheight);
    }
  }
  if(options_menu[MNU_BOX].flags&D_SELECTED){
    for(z=0;z<numboxes;z++){
      polygon(background,4,walkbox[z],walkcolor[z]);
    }
  }
  fclose(fin);
}

void draw_object(unsigned char c){
  unsigned int x,y,z,m;
  unsigned char color,run;
  int i,j,k;
  fin=open_room(resource_list[resource_current].number);
  if(!fin){
    alert("File","not found!","","OK",NULL,0,0);
    return;
  }
  fseek(fin,objs[c].gfxoff[0],SEEK_SET);
  clear_to_color(objpict,main_screen[DLG_OBJECT].bg);
  set_clip(objpict,0,0,objs[c].width,objs[c].height);
  if((version==LOOM_INDY_OLD)||(version==MONK_EGA)){
    if(options_menu[MNU_MSK].flags&D_SELECTED){
      x=lucas_read_int(fin);
      fseek(fin,x-2,SEEK_CUR);
      new_mask(fin,ftell(fin),objpict,objs[c].width,objs[c].height);
    }
    else{
      ega_decode(fin,objpict,objs[c].width,objs[c].height);
    }
  }
  else if(version==MM_ZAK_NEW){
    ladecode(fin,objpict,objs[c].width,objs[c].height);
    if(options_menu[MNU_MSK].flags&D_SELECTED){
      lamask(fin,ftell(fin),objpict,objs[c].width,objs[c].height);
    }
  }
  else if((version==MM_OLD)||(version==ZAK_OLD)){
    old_obj(fin,objpict,objs[c].width>>3,objs[c].height>>3);
  }
  else if(version==MONK_VGA){
    vga_decode(fin,objpict,objs[c].width,objs[c].height);
  }
  else if(version==INDY_256){
    if(options_menu[MNU_MSK].flags&D_SELECTED){
      x=lucas_read_int(fin);
      new_mask(fin,ftell(fin)+x-2,objpict,objs[c].width,objs[c].height);
    }
    else indy_decode(fin,objpict,objs[c].width,objs[c].height);
  }
  else if((version>=MONKEY2)&&(objs[c].images>0)){
    clear_to_color(objpict,MASK_COLOR_16);    
    if(options_menu[MNU_MSK].flags&D_SELECTED){
      if(objs[c].mskoff!=-1) new_mask(fin,objs[c].mskoff,objpict,objs[c].width,objs[c].height);
    }
    else vga_decode(fin,objpict,objs[c].width,objs[c].height);
  }
  fclose(fin);
}

void load_table_00(){
  unsigned int z;
  sprintf(file,"%s00.LFL",game_dir);
  fin=fopen(file,"rb");
  check=lucas_read_int(fin);
  switch(version){
    case MM_OLD:
      numobjects=0x320;
    break;
    case ZAK_OLD:
      numobjects=0x307;
    break;
    case LOOM_INDY_OLD:
    case MM_ZAK_NEW:
      numobjects=lucas_read_int(fin);
    break;
  }
  if(version==LOOM_INDY_OLD){
    for(z=0;z<numobjects;z++){
      objects[z]=lucas_read_long(fin);
    }
  }
  else{
    for(z=0;z<numobjects;z++){
      objects[z]=lucas_read_char(fin);
    }
  }
  switch(version){
    case MM_OLD:
      numrooms=0x37;
    break;
    case ZAK_OLD:
      numrooms=0x3D;
    break;
    case LOOM_INDY_OLD:
    case MM_ZAK_NEW:
      numrooms=lucas_read_char(fin);
    break;
  }
  for(z=0;z<numrooms;z++){
    rooms[z]=lucas_read_char(fin);
  }
  for(z=0;z<numrooms;z++){
    lucas_read_int(fin);
  }
  switch(version){
    case MM_OLD:
      numcostumes=0x23;
    break;
    case ZAK_OLD:
      numcostumes=0x25;
    break;
    case LOOM_INDY_OLD:
    case MM_ZAK_NEW:
      numcostumes=lucas_read_char(fin);
    break;
  }
  for(z=0;z<numcostumes;z++){
    costumes[z]=lucas_read_char(fin);
  }
  for(z=0;z<numcostumes;z++){
    costoff[z]=lucas_read_int(fin);
  }
  switch(version){
    case MM_OLD:
      numscripts=0xC8;
    break;
    case ZAK_OLD:
      numscripts=0x9B;
    break;
    case LOOM_INDY_OLD:
    case MM_ZAK_NEW:
      numscripts=lucas_read_char(fin);
    break;
  }
  for(z=0;z<numscripts;z++){
    scripts[z]=lucas_read_char(fin);
  }
  for(z=0;z<numscripts;z++){
    scroff[z]=lucas_read_int(fin);
  }
  switch(version){
    case MM_OLD:
      numsounds=0x64;
    break;
    case ZAK_OLD:
      numsounds=0x78;
    break;
    case LOOM_INDY_OLD:
    case MM_ZAK_NEW:
      numsounds=lucas_read_char(fin);
    break;
  }
  for(z=0;z<numsounds;z++){
    sounds[z]=lucas_read_char(fin);
  }
  for(z=0;z<numsounds;z++){
    sndoff[z]=lucas_read_int(fin);
  }
  fclose(fin);
}

void load_table_000(){
  unsigned int z,y,x;
  unsigned long size;
  char head[3];
  for(z=0;z<100;z++){
    roomnames[z][0]=0;
  }
  old_crypt=lucas_crypt;
  lucas_crypt=0;
  if (version==INDY_256)
    sprintf(file,"%s00.LFL",game_dir);
  else
    sprintf(file,"%s000.LFL",game_dir);
  fin=fopen(file,"rb");
  size=lucas_read_long(fin);
  lucas_read_head(fin,head,2);
  while(!feof(fin)){
    if(strcmp("RN",head)==0){
      for(z=0;z<(size-6)/10;z++){
        y=lucas_read_char(fin);
        for(x=0;x<9;x++){
          roomnames[y][x]=lucas_read_char(fin)^0xff;
        }
        roomnames[y][9]=0;
      }
      lucas_read_char(fin);
    }
    else if(strcmp("0R",head)==0){
      numrooms=lucas_read_int(fin);
      for(z=0;z<numrooms;z++){
        rooms[z]=lucas_read_char(fin);
        lucas_read_long(fin);
      }
    }
    else if(strcmp("0S",head)==0){
      numscripts=lucas_read_int(fin);
      for(z=0;z<numscripts;z++){
        scripts[z]=lucas_read_char(fin);
        scroff[z]=lucas_read_long(fin);
      }
    }
    else if(strcmp("0N",head)==0){
      numsounds=lucas_read_int(fin);
      for(z=0;z<numsounds;z++){
        sounds[z]=lucas_read_char(fin);
        sndoff[z]=lucas_read_long(fin);
      }
    }
    else if(strcmp("0C",head)==0){
      numcostumes=lucas_read_int(fin);
      for(z=0;z<numcostumes;z++){
        costumes[z]=lucas_read_char(fin);
        costoff[z]=lucas_read_long(fin);
      }
    }
    else if(strcmp("0O",head)==0){
      numobjects=lucas_read_int(fin);
      for(z=0;z<numobjects;z++){
        objects[z]=lucas_read_long(fin);
      }
    }
    else{
      fseek(fin,size-6,SEEK_CUR);
    }
    size=lucas_read_long(fin);
    lucas_read_head(fin,head,2);
  }
  fclose(fin);
  lucas_crypt=old_crypt;
}

void load_table_new(){
  unsigned int z,y,x;
  unsigned long size;
  char head[5];
  for(z=0;z<100;z++){
    roomnames[z][0]=0;
  }
  sprintf(file,"%s%s.%c%c0",game_dir,game_name,pre[0],pre[1]);
  fin=fopen(file,"rb");
  lucas_read_head(fin,head,4);
  size=flip(lucas_read_long(fin));
  while(!feof(fin)){
    if(strcmp("RNAM",head)==0){
      for(z=0;z<(size-8)/10;z++){
        y=lucas_read_char(fin);
        for(x=0;x<9;x++){
          roomnames[y][x]=lucas_read_char(fin)^0xff;
        }
        roomnames[y][9]=0;
      }
      lucas_read_char(fin);
    }
    else if(strcmp("DROO",head)==0){
      numrooms=lucas_read_int(fin);
      for(z=0;z<numrooms;z++){
        rooms[z]=lucas_read_char(fin);
      }
      for(z=0;z<numrooms;z++){
        lucas_read_long(fin);
      }
    }
    else if(strcmp("DSCR",head)==0){
      numscripts=lucas_read_int(fin);
      for(z=0;z<numscripts;z++){
        scripts[z]=lucas_read_char(fin);
      }
      for(z=0;z<numscripts;z++){
        scroff[z]=lucas_read_long(fin);
      }
    }
    else if(strcmp("DSOU",head)==0){
      numsounds=lucas_read_int(fin);
      for(z=0;z<numsounds;z++){
        sounds[z]=lucas_read_char(fin);
      }
      for(z=0;z<numsounds;z++){
        sndoff[z]=lucas_read_long(fin);
      }
    }
    else if(strcmp("DCOS",head)==0){
      numcostumes=lucas_read_int(fin);
      for(z=0;z<numcostumes;z++){
        costumes[z]=lucas_read_char(fin);
      }
      for(z=0;z<numcostumes;z++){
        costoff[z]=lucas_read_long(fin);
      }
    }
    else if(strcmp("DOBJ",head)==0){
      fseek(fin,size-8,SEEK_CUR);
    }
    else if(strcmp("DCHR",head)==0){
      numfonts=lucas_read_int(fin);
      for(z=0;z<numfonts;z++){
        fonts[z]=lucas_read_char(fin);
      }
      for(z=0;z<numfonts;z++){
        fontoff[z]=lucas_read_long(fin);
      }
    }
    else{
      fseek(fin,size-8,SEEK_CUR);
    }
    lucas_read_head(fin,head,4);
    size=flip(lucas_read_long(fin));
  }
  fclose(fin);
}

void reset_screen(){
  main_screen[DLG_GRAPHIC].flags|=D_HIDDEN;
  update_draw(DLG_GRAPHIC);
  main_screen[DLG_GRAPHIC].d1=0;
  clear_to_color(objpict,main_screen[DLG_OBJECT].bg);
  update_draw(DLG_OBJECT);
  main_screen[DLG_OBJLIST].flags|=D_HIDDEN;
  main_screen[DLG_OBJLIST].d1=0;
  object_current=0;
  main_screen[DLG_SLIDER].flags|=D_HIDDEN;
  main_screen[DLG_SLIDER].d2=0;
  main_screen[DLG_SCRIPT].flags|=D_HIDDEN;
  main_screen[DLG_SCRIPT].d2=0;
  strcpy(info_text,"");
}

void reset_menu(){
  options_menu[MNU_BOX].flags|=D_DISABLED;
  options_menu[MNU_PAL].flags|=D_DISABLED;
  options_menu[MNU_MSK].flags|=D_DISABLED;
  options_menu[MNU_BOX].flags&=~D_SELECTED;
  options_menu[MNU_PAL].flags&=~D_SELECTED;
  options_menu[MNU_MSK].flags&=~D_SELECTED;
}

void update_info(){
  main_screen[DLG_INFOTEXT].flags&=~D_HIDDEN;
  if(numobjs){
    sprintf(info_text,"Room #%u (%u,%u) Object #%.3u %.31s (%u,%u,%u,%u)",
    resource_list[main_screen[DLG_LIST].d1].number,
    picwidth,picheight,
    objs[main_screen[DLG_OBJLIST].d1].number,
    objs[main_screen[DLG_OBJLIST].d1].name,
    objs[main_screen[DLG_OBJLIST].d1].x,
    objs[main_screen[DLG_OBJLIST].d1].y,
    objs[main_screen[DLG_OBJLIST].d1].width,
    objs[main_screen[DLG_OBJLIST].d1].height);
  }
  else{
    sprintf(info_text,"Room #%u (%u,%u) ",  
    resource_list[main_screen[DLG_LIST].d1].number,
    picwidth,picheight);
  }
  update_draw(DLG_INFOBACK);
  update_draw(DLG_INFOTEXT);
  draw_draw();
}

int load_room_00(int r){
  unsigned char z,y;
  unsigned char nameoff;
  sprintf(file,"%s%.2u.LFL",game_dir,r);
  fin=fopen(file,"rb");
  if(!fin){
    alert("File",file,"not found!","OK",NULL,0,0);
    return(0);
  }
  fseek(fin,4,SEEK_SET);
  options_menu[MNU_MSK].flags&=~D_DISABLED;
  if((version==MM_OLD)||(version==ZAK_OLD)){
    options_menu[MNU_PAL].flags&=~D_DISABLED;
    picwidth=lucas_read_char(fin);
    picheight=lucas_read_char(fin);
    for(z=0;z<4;z++){
      colors[z]=lucas_read_char(fin);
    }
    fseek(fin,10,SEEK_SET);
    picoff=lucas_read_int(fin);
    fseek(fin,picoff,SEEK_SET);
    old_decode(fin,charmap,256*8);
    fseek(fin,12,SEEK_SET);
    picoff=lucas_read_int(fin);
    fseek(fin,picoff,SEEK_SET);
    old_decode(fin,picmap,picwidth*picheight);
    fseek(fin,14,SEEK_SET);
    picoff=lucas_read_int(fin);
    fseek(fin,picoff,SEEK_SET);
    old_decode(fin,colormap,picwidth*picheight);
    fseek(fin,16,SEEK_SET);
    picoff=lucas_read_int(fin);
    fseek(fin,picoff,SEEK_SET);
    old_decode(fin,maskmap,picwidth*picheight);
    fseek(fin,18,SEEK_SET);
    picoff=lucas_read_int(fin);
    fseek(fin,picoff,SEEK_SET);
    picoff=lucas_read_int(fin);
    old_decode(fin,maskchar,picoff);
    picwidth<<=3;
    picheight<<=3;
  }
  else if((version==MM_ZAK_NEW)||(version==LOOM_INDY_OLD)){
    picwidth=lucas_read_int(fin);
    picheight=lucas_read_int(fin);
    fseek(fin,10,SEEK_SET);
    picoff=lucas_read_int(fin);
    mskoff=lucas_read_int(fin);
  }
  fseek(fin,20,SEEK_SET);
  numobjs=lucas_read_char(fin);
  if(version<=MM_ZAK_NEW)
    boxoff=lucas_read_char(fin);
  else
    boxoff=lucas_read_int(fin);
  if(version==LOOM_INDY_OLD)
    fseek(fin,29,SEEK_SET);
  else
    fseek(fin,28,SEEK_SET);
  for(z=0;z<numobjs;z++){
    objs[z].gfxoff[0]=lucas_read_int(fin);
  }
  for(z=0;z<numobjs;z++){
    objs[z].infoff=lucas_read_int(fin);
  }
  for(z=0;z<numobjs;z++){
    fseek(fin,objs[z].infoff+4,SEEK_SET);
    objs[z].number=lucas_read_int(fin);
    if(version==LOOM_INDY_OLD)
      fseek(fin,objs[z].infoff+16,SEEK_SET);
    else
      fseek(fin,objs[z].infoff+14,SEEK_SET);
    nameoff=lucas_read_char(fin);
    fseek(fin,objs[z].infoff+nameoff,SEEK_SET);
    y=0;
    while((objs[z].name[y++]=lucas_read_char(fin))!=0);
    fseek(fin,objs[z].infoff+7,SEEK_SET);
    objs[z].x=lucas_read_char(fin)<<3;
    objs[z].y=(lucas_read_char(fin)&0xf)<<3;
    fseek(fin,objs[z].infoff+9,SEEK_SET);
    objs[z].width=lucas_read_char(fin)<<3;
    if(version==LOOM_INDY_OLD)
      fseek(fin,objs[z].infoff+15,SEEK_SET);
    else
      fseek(fin,objs[z].infoff+13,SEEK_SET);
    objs[z].height=lucas_read_char(fin)&0xf8;
  }
  fseek(fin,boxoff,SEEK_SET);
  numboxes=lucas_read_char(fin);
  options_menu[MNU_BOX].flags&=~D_DISABLED;
  if(version>=LOOM_INDY_OLD)
    for(z=0;z<numboxes;z++){
      walkbox[z][0]=lucas_read_int(fin);
      walkbox[z][1]=lucas_read_int(fin);
      walkbox[z][2]=lucas_read_int(fin);
      walkbox[z][3]=lucas_read_int(fin);
      walkbox[z][4]=lucas_read_int(fin);
      walkbox[z][5]=lucas_read_int(fin);
      walkbox[z][6]=lucas_read_int(fin);
      walkbox[z][7]=lucas_read_int(fin);
      walkcolor[z]=lucas_read_char(fin);
      lucas_read_char(fin);
    }
  else
    for(z=0;z<numboxes;z++){
      walkbox[z][1]=walkbox[z][7]=lucas_read_char(fin)*2;
      walkbox[z][3]=walkbox[z][5]=lucas_read_char(fin)*2+1;
      walkbox[z][0]=lucas_read_char(fin)*8;
      walkbox[z][6]=lucas_read_char(fin)*8+7;
      walkbox[z][2]=lucas_read_char(fin)*8;
      walkbox[z][4]=lucas_read_char(fin)*8+7;
      walkcolor[z]=lucas_read_char(fin);
      lucas_read_char(fin);
    }
  fclose(fin);
  return(1);
}

int load_room_000(int r){
  unsigned int z,y,x;
  unsigned char nameoff, good=0;
  unsigned long size;
  char head[3];
  fin=open_room(r);
  if(!fin){
    alert("File",file,"not found!","OK",NULL,0,0);
    return(0);
  }
  z=0;
  options_menu[MNU_BOX].flags|=D_DISABLED;
  options_menu[MNU_MSK].flags&=~D_DISABLED;
  size=lucas_read_long(fin);
  lucas_read_head(fin,head,2);
  while(!feof(fin)){
    if(strcmp("LF",head)==0){
      if(lucas_read_int(fin)!=r)
        fseek(fin,size-8,SEEK_CUR);
    }
    else if(strcmp("HD",head)==0){
      picwidth=lucas_read_int(fin);
      picheight=lucas_read_int(fin);
      numobjs=lucas_read_int(fin);
      fseek(fin,size-12,SEEK_CUR);
      good=1;
    }
    else if(strcmp("BX",head)==0){
      options_menu[MNU_BOX].flags&=~D_DISABLED;
      numboxes=lucas_read_char(fin);
      for(x=0;x<numboxes;x++){
        walkbox[x][0]=lucas_read_int(fin);
        walkbox[x][1]=lucas_read_int(fin);
        walkbox[x][2]=lucas_read_int(fin);
        walkbox[x][3]=lucas_read_int(fin);
        walkbox[x][4]=lucas_read_int(fin);
        walkbox[x][5]=lucas_read_int(fin);
        walkbox[x][6]=lucas_read_int(fin);
        walkbox[x][7]=lucas_read_int(fin);
        walkcolor[x]=lucas_read_int(fin);
        if (version!=INDY_256) lucas_read_int(fin);
      }
      if(version==INDY_256)  fseek(fin,size-7-numboxes*18,SEEK_CUR);
      else fseek(fin,size-7-numboxes*20,SEEK_CUR);
    }
    else if(!strcmp(head,"PA")){
      lucas_read_char(fin);
      lucas_read_char(fin);
      for(y=0;y<256;y++){
        vga_pal[y].r=lucas_read_char(fin);
        vga_pal[y].g=lucas_read_char(fin);
        vga_pal[y].b=lucas_read_char(fin);
      }
    }
    else if(strcmp("BM",head)==0){
      picoff=ftell(fin);
      mskoff=ftell(fin)+lucas_read_int(fin);
      if(mskoff+16>picoff+size) mskoff=-1;
      fseek(fin,picoff+size-6,SEEK_SET);
    }
    else if(strcmp("OI",head)==0){
      objs[z].number=lucas_read_int(fin);
      objs[z].gfxoff[0]=ftell(fin);
      fseek(fin,objs[z].gfxoff[0]+size-8,SEEK_SET);
      z++;
    }
    else if(strcmp("OC",head)==0){
      y=lucas_read_int(fin);
      z=0;
      while((y!=objs[z].number)&&(z<numobjs))
        z++;
      objs[z].infoff=ftell(fin)-2;
      lucas_read_char(fin);
      objs[z].x=lucas_read_char(fin)<<3;
      objs[z].y=lucas_read_char(fin)<<3;
      objs[z].width=lucas_read_char(fin)<<3;
      fseek(fin,5,SEEK_CUR);
      objs[z].height=lucas_read_char(fin)&0xf8;
      nameoff=lucas_read_char(fin);
      fseek(fin,nameoff-13-6,SEEK_CUR);
      y=0;
      while((objs[z].name[y++]=lucas_read_char(fin))!=0);
      fseek(fin,objs[z].infoff+size-6,SEEK_SET);
      z++;
    }
    else if((strcmp("LE",head)!=0)&&(strcmp("RO",head)!=0))
      fseek(fin,size-6,SEEK_CUR);
    size=lucas_read_long(fin);
    lucas_read_head(fin,head,2);
  }
  fclose(fin);
  if(good==0) alert("There is no room!",NULL,NULL,"OK",NULL,0,0);
  return(good);
}

int load_room_new(int r){
  unsigned long size[2],kang[2],roomend;
  char head[2][5];
  char firstpal=1;
  long max;
  unsigned int x,y,z,n;
  int read_head(int level){
    lucas_read_head(fin,head[level],4);
    size[level]=flip(lucas_read_long(fin));
  }
  int check_head(char *s, int level){
    return(!strncmp(s,head[level],strlen(s)));
  }
  lucas_crypt=old_crypt;
  fin=open_room(r);
  if(!fin){
    alert("File","not found!","","OK",NULL,0,0);
    return(0);
  }
  read_head(0);
  while(!check_head("LOFF",0)){
    read_head(0);
  }
  n=lucas_read_char(fin);
  x=lucas_read_char(fin);
  y=lucas_read_long(fin)&0xffffff;
  z=0;
  while((x!=r)&&(z++<n)){
    x=lucas_read_char(fin);
    y=lucas_read_long(fin)&0xffffff;
  }
  if(z>n){
    alert("Room","not found!","","OK",NULL,0,0);
    fclose(fin);
    return(0);
  }
  fseek(fin,y,SEEK_SET);
  read_head(0);
  roomend=ftell(fin)+size[0]-8;
  z=0;
  options_menu[MNU_MSK].flags&=~D_DISABLED;
  while(ftell(fin)<roomend){
    kang[0]=ftell(fin);
    read_head(0);
    if(check_head("RMHD",0)){
      picwidth=lucas_read_int(fin);
      picheight=lucas_read_int(fin);
      numobjs=lucas_read_int(fin);      
    }
    else if(check_head("TRNS",0)){
      trans_color=lucas_read_char(fin);
    }
    else if(check_head("CLUT",0)||check_head("APAL",0)){
      if(firstpal){
        for(x=0;x<256;x++){
          vga_pal[x].r=lucas_read_char(fin);
          vga_pal[x].g=lucas_read_char(fin);
          vga_pal[x].b=lucas_read_char(fin);
        }
        firstpal=0;
      }
    }
    else if(check_head("BOXD",0)){
      options_menu[MNU_BOX].flags&=~D_DISABLED;
      numboxes=lucas_read_int(fin);
      for(x=0;x<numboxes;x++){
        walkbox[x][0]=lucas_read_int(fin);
        walkbox[x][1]=lucas_read_int(fin);
        walkbox[x][2]=lucas_read_int(fin);
        walkbox[x][3]=lucas_read_int(fin);
        walkbox[x][4]=lucas_read_int(fin);
        walkbox[x][5]=lucas_read_int(fin);
        walkbox[x][6]=lucas_read_int(fin);
        walkbox[x][7]=lucas_read_int(fin);
        walkcolor[x]=lucas_read_int(fin);
        lucas_read_int(fin);
      }
    }
    else if(check_head("RMIM",0)){
      max=kang[0]+size[0];
      mskoff=-1;
      while(ftell(fin)<max){
        kang[1]=ftell(fin);
        read_head(1);
        if(check_head("SMAP",1)){
          picoff=kang[1];
        }
        if(check_head("ZP",1)){
          if(mskoff==-1) mskoff=kang[1];
        }
        if(!check_head("IM0",1)) fseek(fin,kang[1]+size[1],SEEK_SET);
      }
    }
    else if(check_head("OBIM",0)){
      n=0;
      max=kang[0]+size[0];
      while(ftell(fin)<max){
        kang[1]=ftell(fin);
        read_head(1);
        if(check_head("IMHD",1)){
          objs[z].number=lucas_read_int(fin);
          objs[z].images=lucas_read_int(fin);
          fseek(fin,4,SEEK_CUR);
          objs[z].x=lucas_read_int(fin);
          objs[z].y=lucas_read_int(fin);
          objs[z].width=lucas_read_int(fin);
          objs[z].height=lucas_read_int(fin)&0xF8;
        }
        if(check_head("SMAP",1)){
          objs[z].gfxoff[n]=kang[1];
          objs[z].mskoff=-1;
          n++;
        }
        if(check_head("ZP",1)){
          if(objs[z].mskoff==-1) objs[z].mskoff=kang[1];
        }
        if(!check_head("IM0",1)) fseek(fin,kang[1]+size[1],SEEK_SET);        
      }
      z++;
    }
    else if(check_head("CDHD",0)){
      y=lucas_read_int(fin);
      for(x=0;x<z;x++){
        if(y==objs[x].number) break;
      }
    }
    else if(check_head("OBNA",0)){
      y=0;
      while((objs[x].name[y++]=lucas_read_char(fin))!=0);
    }
    if((!check_head("PALS",0))&&(!check_head("WRAP",0))&&(!check_head("OBCD",0))) fseek(fin,kang[0]+size[0],SEEK_SET);
  }
  fclose(fin);
  return(1);
}

int walk_box(){
  options_menu[MNU_BOX].flags^=D_SELECTED;
  draw_room();
  update_draw(DLG_GRAPHIC);
  draw_draw();
  return(D_O_K);
}

int c64_pal(){
  options_menu[MNU_PAL].flags^=D_SELECTED;
  draw_room();
  draw_object(main_screen[DLG_OBJLIST].d1);
  update_draw(DLG_GRAPHIC);
  update_draw(DLG_OBJECT);
  draw_draw();
  return(D_O_K); 
}

int show_mask(){
  options_menu[MNU_MSK].flags^=D_SELECTED;
  draw_room();
  draw_object(main_screen[DLG_OBJLIST].d1);
  update_draw(DLG_GRAPHIC);
  update_draw(DLG_OBJECT);
  draw_draw();
  return(D_O_K);
}

int set_mspeed(){
  popup_dialog(mouse_speed, -1);
  set_mouse_speed(atoi(xspeed),atoi(yspeed));
  return(D_O_K);
}

char *list_getter(int index, int *list_size)
{  
  if(index < 0){
    if(list_size){
      *list_size = resource_count;
    }
    return(NULL);
  }
  return(resource_list[index].name);
}

long load_resource(DIALOG *d){
  int done=0;
  unsigned long size;
  char head[5];
  unsigned int x,y,z,n;
  long resource_size;
  lucas_crypt=old_crypt;
  if(((version>=LOOM_INDY_OLD)&&(version<=MONK_VGA))&&(resource_list[d->d1].type==FONT)){
    sprintf(file,"%s%.2u.LFL",game_dir,resource_list[d->d1].room);
    fin=fopen(file,"rb");
    if(!fin){
      alert("File",file,"not found!","OK",NULL,0,0);
      return(0);
    }
    old_crypt=lucas_crypt;
    lucas_crypt=0;
    resource_size=lucas_read_int(fin);
    fseek(fin,-2,SEEK_CUR);
    return(resource_size);
  }
  fin=open_room(resource_list[d->d1].room);
  if(!fin){
    alert("File",file,"not found!","OK",NULL,0,0);
    return(0);
  }
  if(version>=MONKEY2){
    lucas_read_head(fin,head,4);
    size=flip(lucas_read_long(fin));
    while(strcmp("LOFF",head)!=0){
      lucas_read_head(fin,head,4);
      size=flip(lucas_read_long(fin));
    }
    n=lucas_read_char(fin);
    z=0;
    x=lucas_read_char(fin);
    y=lucas_read_long(fin)&0xffffff;
    while((x!=resource_list[d->d1].room)&&(z++<n)){
      x=lucas_read_char(fin);
      y=lucas_read_long(fin)&0xffffff;
    }
    if(z>n){
      alert("Room","not found!","","OK",NULL,0,0);
      fclose(fin);
      return(0);
    }
    fseek(fin,y-4,SEEK_SET);    
    if(resource_list[d->d1].offset+8>flip(lucas_read_long(fin))){
      alert("Outside of room!",NULL,"","OK",NULL,0,0);
      fclose(fin);
      return(0);
    }
    fseek(fin,y+resource_list[d->d1].offset,SEEK_SET);
    lucas_read_head(fin,head,4);
    if(strcmp(head,mi2head[resource_list[d->d1].type])){
      alert("Not valid!",NULL,"","OK",NULL,0,0);
      fclose(fin);
      return(0);
    }
    resource_size=flip(lucas_read_long(fin));
    fseek(fin,-8,SEEK_CUR);
  }
  else if((version==MONK_EGA)||(version==MONK_VGA)){
    size=lucas_read_long(fin);
    lucas_read_head(fin,head,2);
    while(!done){
      if(strcmp("LF",head)==0){
        if(lucas_read_int(fin)!=resource_list[d->d1].room)
          fseek(fin,size-8,SEEK_CUR);
        else
          done=1;
      }
      else if(strcmp("LE",head)!=0)
        fseek(fin,size-6,SEEK_CUR);
      size=lucas_read_long(fin);
      lucas_read_head(fin,head,2);
    }
    fseek(fin,resource_list[d->d1].offset-6,SEEK_CUR);
    resource_size=lucas_read_long(fin);
    lucas_read_head(fin,head,2);
    if(strcmp(head,oldhead[resource_list[d->d1].type])){
      alert("Not valid!",NULL,"","OK",NULL,0,0);
      fclose(fin);
      return(0);
    }
    fseek(fin,-6,SEEK_CUR);
  }
  else{
    fseek(fin,resource_list[d->d1].offset,SEEK_SET);
    resource_size=lucas_read_int(fin);
    fseek(fin,-2,SEEK_CUR);
  }
  return(resource_size);
}

void view_unknown(DIALOG *d){
  unsigned int x,y,z;
  unsigned int resource_size;
  reset_screen();
  main_screen[DLG_SCRIPT].flags&=~D_HIDDEN;
  resource_size=load_resource(d);
  if(!resource_size) return;
  for(z=0;z<resource_size;z++){
    x=lucas_read_char(fin)&0x7F;
    if(x>32) scr_text[z]=x;
    else scr_text[z]=' ';
  }
  scr_text[z]=0;
  fclose(fin);
}

void view_font(DIALOG *d){
  int getbit(int m)
  {
    static unsigned int buffer, mask;
    if(m!=-1){
      mask=m;
      return(-1);
    }
    if ((mask >>= 1) == 0){
      buffer = lucas_read_char(fin);  mask = 0x80;
    }
    return ((buffer & mask) != 0);
  }

  unsigned char c,letter,width,height,font_colors,maxh;
  unsigned long off,kang;
  unsigned int x,y,z,sx,sy;
  unsigned int resource_size;
  reset_screen();
  resource_size=load_resource(d);
  if(version>=MONKEY2) fseek(fin,8,SEEK_CUR);
  kang=ftell(fin);
  sx=0;
  sy=0;
  if((version==LOOM_INDY_OLD)||(version==INDY_256)){
    font_colors=1;
    maxh=8;
  }
  else{
    fseek(fin,kang+0x15,SEEK_SET);
    font_colors=lucas_read_char(fin);
    maxh=lucas_read_char(fin);
  }
  clear_to_color(background,main_screen[DLG_GRAPHIC].bg);
  main_screen[DLG_GRAPHIC].flags&=~D_HIDDEN;
  letter=0;
  while(1==1){
    if((version==LOOM_INDY_OLD)||(version==INDY_256)){
      fseek(fin,kang+6,SEEK_SET);
      off=lucas_read_char(fin);
      if((off+letter*8+7)>resource_size) break;
      fseek(fin,kang+off+letter*8,SEEK_SET);
      width=8;
      height=8;
    }
    else{
      fseek(fin,kang+0x19+letter*4,SEEK_SET);
      off=lucas_read_long(fin);
      if((off>resource_size)||(letter>0x90)) break;
      fseek(fin,kang+off+0x15,SEEK_SET);
      width=lucas_read_char(fin);
      height=lucas_read_char(fin);
      lucas_read_char(fin);
      lucas_read_char(fin);
    }
    getbit(0);
    if(sx+width>main_screen[DLG_GRAPHIC].w){
      sx=0;
      sy+=maxh+1;
    }
    for(y=0;y<height;y++){
      for(x=0;x<width;x++){
        c=0;
        for(z=0;z<font_colors;z++) c=(getbit(-1))|c<<1;
        if(c) putpixel((BITMAP *)main_screen[DLG_GRAPHIC].dp,sx+x,sy+y+maxh-height,makecol(ega_pal[c].r*4,ega_pal[c].g*4,ega_pal[c].b*4));
      }
    }
    sx+=width;
    letter++;
  }
  fclose(fin);
  lucas_crypt=old_crypt;
  update_draw(DLG_GRAPHIC);
  draw_draw();
}

void play_towns(DIALOG *d){
  unsigned char c;
  int x;
  SAMPLE *snd;
  unsigned int resource_size;
  if(towns==1){
    resource_size=load_resource(d);
    if(!resource_size) return;
    if(resource_size>30){
      snd=create_sample(8,0,11000,resource_size-0x36);
      fseek(fin,0x16,SEEK_CUR);
      for(x=0;x<8;x++) file[x]=lucas_read_char(fin);
      file[8]=0;
      fseek(fin,0x20-8,SEEK_CUR);
      for(x=0;x<(resource_size-0x36);x++){
        c=lucas_read_char(fin);
        if(c<0x80) c=0x7F-c;
        ((unsigned char*)snd->data)[x]=c;
      }
      fclose(fin);
      lock_sample(snd);
      play_sample(snd,255,127,1000,0);
      alert("Now playing...",file,NULL,"Stop",NULL,0,0);
      destroy_sample(snd);
    }
    else{
      fseek(fin,0x16,SEEK_CUR);
      c=lucas_read_char(fin);
      fclose(fin);
      sprintf(file,"CD track #%u",c);
      if(cd_play(c+1)!=0){
        alert("Error playing",file,NULL,"OK",NULL,0,0);
        return;
      }
      alert("Now playing...",file,NULL,"Stop",NULL,0,0);
      cd_stop();
    }
  }
}

void play_digi(DIALOG *d){
  long size,freq,x;
  int n;
  SAMPLE *snd;
  old_crypt=lucas_crypt;
  lucas_crypt=0;
  sprintf(file,"%sMONSTER.SOU",game_dir);
  fin=fopen(file,"rb");
  fseek(fin,resource_list[d->d1].offset,SEEK_SET);
  fseek(fin,0x14,SEEK_CUR);
  n=lucas_read_int(fin);
  fseek(fin,n-0x16,SEEK_CUR);
  n=lucas_read_char(fin);
  if(n!=1){
    alert("Complex .VOC file!",NULL,"E-mail me","OK",NULL,0,0);
    fclose(fin);
    lucas_crypt=old_crypt;
    return;
  }
  size=lucas_read_long(fin)&0xFFFFFF;
  fseek(fin,-1,SEEK_CUR);
  freq=1000000/(256-lucas_read_char(fin));
  if(lucas_read_char(fin)!=0){
    alert("Compressed .VOC file!",NULL,"E-mail me","OK",NULL,0,0);
    fclose(fin);
    lucas_crypt=old_crypt;
    return;
  }
  snd=create_sample(8,0,freq,size-2);
  for(x=0;x<size-2;x++)
    ((unsigned char*)snd->data)[x]=lucas_read_char(fin);
  fclose(fin);
  lucas_crypt=old_crypt;
  lock_sample(snd);
  play_sample(snd,255,127,1000,0);
  alert("Now playing...",NULL,NULL,"Stop",NULL,0,0);
  destroy_sample(snd);
}

void play_mid(DIALOG *d){
  char head[5];
  long donde;
  unsigned char c;
  long size,freq,x;
  int n;
  SAMPLE *snd;
  MIDI *music;
  unsigned int resource_size;
  resource_size=load_resource(d);
  if(!resource_size) return;
  donde=ftell(fin);
  while(1==1){
    lucas_read_head(fin,head,4);
    size=flip(lucas_read_long(fin));
    if((ftell(fin)-donde)>resource_size) break;
    if((strncmp(head,"MD",2)==0)||(strcmp(head,"WVhd")==0)){
      fseek(fin,size,SEEK_CUR);
    }
    if(strcmp(head,"MThd")==0){
      music=malloc(sizeof(MIDI));
      for (x=0; x<MIDI_TRACKS; x++) {
        music->track[x].data=NULL;
        music->track[x].len=0;
      }
      fseek(fin,4,SEEK_CUR);
      music->divisions=lucas_read_char(fin);
      music->divisions<<=8;
      music->divisions|=lucas_read_char(fin);
      fseek(fin,size-6,SEEK_CUR);
    }
    if(strcmp(head,"MTrk")==0){
      music->track[0].len=size;
      music->track[0].data=malloc(size);
      for(x=0;x<size;x++) music->track[0].data[x]=lucas_read_char(fin);
      lock_midi(music);
      play_midi(music,0);
      alert("Now playing MIDI...",NULL,NULL,"Stop",NULL,0,0);
      stop_midi();
      music->track[0].len=0;
      free(music->track[0].data);
    }
    if(strcmp(head,"WVdt")==0){
      n=lucas_read_char(fin);
      if(n!=1){
        alert("Complex .VOC file!",NULL,"E-mail me","OK",NULL,0,0);
        fclose(fin);
        return;
      }
      size=lucas_read_long(fin)&0xFFFFFF;
      fseek(fin,-1,SEEK_CUR);
      freq=1000000/(256-lucas_read_char(fin));
      if(lucas_read_char(fin)!=0){
        alert("Compressed .VOC file!",NULL,"E-mail me","OK",NULL,0,0);
        fclose(fin);
        return;
      }
      snd=create_sample(8,0,freq,size-2);
      for(x=0;x<size-2;x++)
        ((unsigned char*)snd->data)[x]=lucas_read_char(fin);
      fclose(fin);
      lock_sample(snd);
      play_sample(snd,255,127,1000,0);
      alert("Now playing...",NULL,NULL,"Stop",NULL,0,0);
      destroy_sample(snd);
    }
  }
  fclose(fin);
}

void draw_cost(DIALOG *d){
  unsigned int x,y,z,width,height;
  unsigned int resource_size;
  unsigned char color,run,f,n,format,m;
  unsigned int first,off,max,limit;
  unsigned char pal[32];
  long donde;
  reset_screen();
  if(version>=INDY_256) load_room(resource_list[d->d1].room);
  resource_size=load_resource(d);
  if(!resource_size) return;
  if(version>=MONKEY2){
    fseek(fin,8,SEEK_CUR);
    resource_size-=8;
  }
  if(version<MM_ZAK_NEW) fseek(fin,4,SEEK_CUR);
  donde=ftell(fin);
  if(version>MONKEY2);
  else if(version==MONKEY2){
    fseek(fin,4,SEEK_CUR);
    if(lucas_read_int(fin)==0x4F43);
    else{
      fseek(fin,-6,SEEK_CUR);
      donde-=6;
    }
  }
  else if(version>=MONK_EGA) fseek(fin,6,SEEK_CUR);
  else if(version>=MM_ZAK_NEW) fseek(fin,4,SEEK_CUR);
  lucas_read_char(fin);
  format=lucas_read_char(fin);
  if(format&1) f=5;
  else f=4;
  if(version>=MONK_EGA) for(x=0;x<(1<<f);x++) pal[x]=lucas_read_char(fin);
  else if(version>=MM_ZAK_NEW)lucas_read_char(fin);
  lucas_read_int(fin);
  for(x=0;(x<8)||((version>ZAK_OLD)&&(x<16));x++){
    y=lucas_read_int(fin);
    if((x==0)||(y<first)) first=y;
  }
  fseek(fin,donde+first,SEEK_SET);
  do{
    max=lucas_read_int(fin);
  }while(max==0);
  fseek(fin,donde+first,SEEK_SET);
  n=0;
  while(1==1){
    x=0;
    y=0;
    do{
      off=lucas_read_int(fin);
      limit=lucas_read_int(fin);
      if(ftell(fin)>(donde+max)) limit=resource_size-1;
      fseek(fin,-2,SEEK_CUR);
      if(((format&0x7F)>=0x60)&&((limit-off)<=14)) off=0;
      else if((limit-off)<=12) off=0;
      n++;
    }while(off==0);
    if(ftell(fin)>(donde+max)) break;
    fseek(fin,donde+off,SEEK_SET);
    if(version<=ZAK_OLD){
      width=lucas_read_char(fin);
      width<<=3;
      height=lucas_read_char(fin);
    }
    else{
      width=lucas_read_int(fin);
      height=lucas_read_int(fin);
    }
    clear_to_color(objpict,main_screen[DLG_OBJECT].bg);
    set_clip(objpict,0,0,width,height);
    if((format&0x7F)>=0x60) fseek(fin,5*2,SEEK_CUR);
    else if(format==0x57) fseek(fin,4,SEEK_CUR);
    else fseek(fin,4*2,SEEK_CUR);
    while(x<width){
      color=lucas_read_char(fin);
	if(format==0x57){
	if(color&0x80){
		run=color&0x7f;
		color=lucas_read_char(fin);
                for(z=0;z<run;z++){
                        for(m=0;m<4;m++){
                                lucas_pixel(objpict,x+6-m*2,y,(color>>(m*2))&3);
                                lucas_pixel(objpict,x+6-m*2+1,y,(color>>(m*2))&3);
                        }
                        y++;
                        if(y>=height){
                                y=0;
                                x+=8;
                        }
                }
	}
	else{
		run=color;
		for(z=0;z<run;z++){
			color=lucas_read_char(fin);
                        for(m=0;m<4;m++){
                                lucas_pixel(objpict,x+6-m*2,y,(color>>(m*2))&3);
                                lucas_pixel(objpict,x+6-m*2+1,y,(color>>(m*2))&3);
                        }
			y++;
                        if(y>=height){
				y=0;
                                x+=8;
			}			
		}
	}

	}
	else{
	      run=color&((1<<(8-f))-1);
	      if(run==0) run=lucas_read_char(fin);
	      color>>=(8-f);
	      for(z=0;z<run;z++){
	        if(version>=INDY_256) lucas_pixel(objpict,x,y,pal[color]);
	        else lucas_pixel(objpict,x,y,color);
	        y++;
	        if(y>=height){
	          y=0;
	          x++;
	        }
	      }
	}
    }
    update_draw(DLG_OBJECT);
    draw_draw();
    while((!mouse_b)&&(!keypressed()));
    if(mouse_b&2){
      while(mouse_b);
      break;
    }
    if(key[KEY_ESC]){
      while(keypressed()) readkey();
      break;
    }
    while(mouse_b);
    while(keypressed()) readkey();
    n++;
    fseek(fin,donde+first+n*2,SEEK_SET);
  }
  fclose(fin);
}

int my_list_proc(int msg, DIALOG *d, int c){
  int result=0;
  int done=0;
  unsigned long size;
  char head[5];
  unsigned int x,y,z;
  unsigned int resource_size;
  unsigned char temp;
  if((msg == MSG_DCLICK)||((msg==MSG_CHAR)&&(key[KEY_SPACE]))){
    result|=d_list_proc(msg, d, c);
    resource_current=d->d1;
    text_mode(255);
    switch(resource_list[d->d1].type){
      case ROOM:
        if(load_room==NULL)
          break;
        if(load_room(resource_list[main_screen[DLG_LIST].d1].number)){
          for(x=0;x<numobjs;x++)
            uconvert(LangToUni(objs[x].name),U_UNICODE,objs[x].name,U_UTF8,80);
          reset_screen();
          main_screen[DLG_OBJLIST].d1=0;
          main_screen[DLG_OBJLIST].d2=0;        
          draw_room();
          if(numobjs>0){
            draw_object(0);
            main_screen[DLG_OBJLIST].flags&=~D_HIDDEN;
          }
          main_screen[DLG_SLIDER].d1=picwidth-main_screen[DLG_GRAPHIC].w;
          main_screen[DLG_SLIDER].flags&=~D_HIDDEN;
          if(main_screen[DLG_SLIDER].d1<1){
            if(main_screen[DLG_SLIDER].flags & D_GOTFOCUS){
              main_screen[DLG_SLIDER].flags&=~D_GOTFOCUS;
              player->focus_obj=-1;
            }
            main_screen[DLG_SLIDER].flags|=D_HIDDEN;
            main_screen[DLG_SLIDER].d1=1;
          }
          update_draw(DLG_GRAPHIC);
          update_draw(DLG_SLIDER);
          update_draw(DLG_OBJECT);
          update_draw(DLG_OBJLIST);
          draw_draw(); 
          update_info();
        }
      break;
      case FONT:
        view_font(d);
      break;
      case SOUND:
        if(towns) play_towns(d);
        else if(version>=MONKEY2) play_mid(d);
        else view_unknown(d);
        result|=D_REDRAW;
      break;
      case COSTUME:
        draw_cost(d);
        result|=D_REDRAW;
      break;
      case DIGI:
        play_digi(d);
      break;
      default:
        view_unknown(d);
        result|=D_REDRAW;
      break;
    }
  }
  else if(((msg == MSG_CLICK)&&(mouse_b & 2))||((msg==MSG_CHAR)&&(key[KEY_INSERT]))){
    result|=d_list_proc(msg, d, c);
    if(resource_count){
      if(alert("Save",resource_list[d->d1].name,"to disk?","Yes","No",0,0)!=2){
        switch(resource_list[d->d1].type){
          case COSTUME:
            sprintf(file,"%sCOSTUME.%.3u",game_dir,resource_list[d->d1].number);
          break;
          case ROOM:
            sprintf(file,"%sROOM.%.3u",game_dir,resource_list[d->d1].number);
          break;
          case SCRIPT:
            sprintf(file,"%sSCRIPT.%.3u",game_dir,resource_list[d->d1].number);
          break;
          case SOUND:
            sprintf(file,"%sSOUND.%.3u",game_dir,resource_list[d->d1].number);
          break;
          case FONT:
            sprintf(file,"%sFONT.%.3u",game_dir,resource_list[d->d1].number);
          break;
          case DIGI:
            sprintf(file,"%sDIGI.%.3u",game_dir,resource_list[d->d1].number);
          break;
        }
        if(file_select("Enter file name:",file,NULL)){
          fout=fopen(file,"wb");
          if(!fout){
            alert("File",file,"cannot be written!","OK",NULL,0,0);
            return(0);
          }
          resource_size=load_resource(d);
          for(z=0;z<resource_size;z++){
            temp=lucas_read_char(fin);
            fwrite(&temp,1,1,fout);
          }
          fclose(fout);
          fclose(fin);
        }
      }
    }
    result|=D_REDRAW;
  }
  else{
    result|=d_list_proc(msg, d, c);
  }
  return(result);
}

char *obj_getter(int index, int *list_size)
{
  if(index < 0){
    if(list_size){
      *list_size = numobjs;
    }
    return(NULL);
  }
  sprintf(obj_text,"#%.3u %.31s",objs[index].number,objs[index].name);
  return(obj_text);
}

int obj_list_proc(int msg, DIALOG *d, int c){
  int result=0;
  unsigned char temp;
  unsigned short object_size,z;
  if(((msg == MSG_CLICK)&&(mouse_b & 2))||((msg==MSG_CHAR)&&(key[KEY_INSERT]))){
    result|=d_list_proc(msg, d, c);
    sprintf(obj_text,"#%u %s",objs[d->d1].number,objs[d->d1].name);
    if(alert("Save object",obj_text,"to disk?","Yes","No",0,0)!=2){
      sprintf(file,"%sOBJECT.%.3u",game_dir,objs[d->d1].number);
      if(file_select("Enter file name:",file,NULL)){
        fout=fopen(file,"wb");
        if(!fout){
          alert("File",file,"cannot be written!","OK",NULL,0,0);
          return(0);
        }
        fin=open_room(resource_list[resource_current].number);
        if(!fin){
          alert("File",file,"not found!","OK",NULL,0,0);
          return(0);
        }
        fseek(fin,objs[d->d1].infoff,SEEK_SET);
        object_size=lucas_read_int(fin);
        fwrite(&object_size,2,1,fout);
        for(z=0;z<object_size-2;z++){
          temp=lucas_read_char(fin);
          fwrite(&temp,1,1,fout);
        }
        fclose(fin);
        fclose(fout);
      }
    }
  }
  else if((msg == MSG_DCLICK)||((msg==MSG_CHAR)&&(key[KEY_SPACE]))){
    result|=d_list_proc(msg, d, c);
    sprintf(obj_text,"#%u %s",objs[d->d1].number,objs[d->d1].name);
    switch(alert3("Draw object",obj_text,"to the screen?","Draw","Remove","Cancel",0,0,0)){
      case 1:
        masked_blit(objpict,background,0,0,objs[d->d1].x,objs[d->d1].y,objs[d->d1].width,objs[d->d1].height);
        update_draw(DLG_GRAPHIC);
        draw_draw();
      break;
      case 2:
        set_clip(background,objs[d->d1].x,objs[d->d1].y,objs[d->d1].x+objs[d->d1].width-1,objs[d->d1].y+objs[d->d1].height-1);
        draw_room();
        set_clip(background,0,0,MAX_BACK,main_screen[DLG_GRAPHIC].h);
        update_draw(DLG_GRAPHIC);
        draw_draw();
      break;
    }
  }
  else{
    result|=d_list_proc(msg,d,c);
  }
  if(d->d1!=object_current){
    object_current=d->d1;
    draw_object(d->d1);
    update_draw(DLG_OBJECT);
    draw_draw();
    update_info();
  }
  return(result);
}

int my_bitmap_proc(int msg, DIALOG *d, int c)
{
  int viewx;
  int x,y,z;
  polygons polys[256];
  switch (msg) {
    case MSG_IDLE:
      if(d->d1!=main_screen[DLG_SLIDER].d2){
        d->d1=main_screen[DLG_SLIDER].d2;
        show_mouse(NULL);
        SEND_MESSAGE(d,MSG_DRAW,0);
        show_mouse(screen);
      }
      break;
    case MSG_DRAW:
      blit((BITMAP *)d->dp,screen,d->d1,d->d2,d->x,d->y,d->w,d->h);
      break;
    case MSG_CLICK:
      if((mouse_b & 2)&&((version==MM_OLD)||(version==ZAK_OLD))){
        sprintf(roomcol1,"%X",colors[1]);
        sprintf(roomcol2,"%X",colors[2]);
        popup_dialog(room_col, -1);
        sscanf(_strupr(roomcol1),"%X",&colors[1]);
        sscanf(_strupr(roomcol2),"%X",&colors[2]);
        draw_room();
        update_draw(DLG_GRAPHIC);
        update_draw(DLG_OBJECT);
        draw_draw();
      }
      else if(!(main_screen[DLG_SLIDER].flags & D_HIDDEN)){
        int oldmouse=mouse_x;
        int mx;
        viewx=main_screen[DLG_SLIDER].d2;
        while(mouse_b){
          mx=mouse_x;
          if(oldmouse!=mx){
            viewx-=(mx-oldmouse);
            if(viewx<0) viewx=0;
            if(viewx>main_screen[DLG_SLIDER].d1) viewx=main_screen[DLG_SLIDER].d1;
            main_screen[DLG_SLIDER].d2=d->d1=viewx;
            oldmouse=mx;
            show_mouse(NULL);
            SEND_MESSAGE(d,MSG_DRAW,0);
            SEND_MESSAGE(&main_screen[DLG_SLIDER],MSG_DRAW,0);
            show_mouse(screen);
          }
        }
      }
      break;
   }
   return(D_O_K);
}

int sort_function( const void *a, const void *b)
{
  return(strncmp((char *)a,(char *)b,1));
}

int quit_proc(){
  return(D_CLOSE);
}

int load_proc(){
  unsigned int x,y,z;
  long size;
  char head[5];
  strcpy(temp_dir,game_dir);
  if(!file_select("Select a File in the Game Dir:",temp_dir,"LFL;000;SM0;LA1")) return(D_REDRAW);
  oldversion=version;
  version=0;
  for(x=strlen(temp_dir);(x>0)&&(temp_dir[x]!='\\');x--) temp_dir[x]=0;
  sprintf(file,"%s00.LFL",temp_dir);
  fin=fopen(file,"rb");
  if(fin){
    fseek(fin,0,SEEK_END);
    fsize=ftell(fin);
    fseek(fin,0,SEEK_SET);
    fread((char *)&check,2,1,fin);
    fclose(fin);
    check^=0xffff;
    if((check==0xa31)&&(fsize>1920))
      version=MM_OLD;
    else if ((check==0xa31)&&(fsize<=1920))
      version=ZAK_OLD;
    else if(check==0x100){
      sprintf(file,"%s99.LFL",temp_dir);
      if(finder=_findfirst(file,&fileinfo)!=-1){
        version=LOOM_INDY_OLD;
        _findclose(finder);
      }
      else
        version=MM_ZAK_NEW;
    }
    else if(check==0xFE08){
      version=INDY_256;
    }
  }
  sprintf(file,"%s000.LFL",temp_dir);
  if(finder=_findfirst(file,&fileinfo)!=-1){
    version=MONK_EGA;
    sprintf(file,"%sDISK01.LEC",temp_dir);
    fin=fopen(file,"rb");
    fseek(fin,0,SEEK_END);
    if(ftell(fin)>1090000l)
      version=MONK_VGA;
    fclose(fin);
    sprintf(file,"%s90?.LFL",temp_dir);
    for(z=0;z<16;z++)
      fonts[z]=0;
    finder=_findfirst(file,&fileinfo);
    do{
      z=fileinfo.name[strlen(fileinfo.name)-5]-'0';
      if(z>numfonts) numfonts=z+1;
      fonts[z]=900+z;
      fontoff[z]=0;
    }while(_findnext(finder,&fileinfo)!=-1);
    _findclose(finder);
  }
  towns=0;
  sprintf(file,"%s*.EXP",temp_dir);
  if(finder=_findfirst(file,&fileinfo)!=-1){
    towns=1;
    _findclose(finder);    
  }
  if((version==LOOM_INDY_OLD)||(version==INDY_256)){
    numfonts=1;
    for(z=99;z>94;z--){
      sprintf(file,"%s%.2u.LFL",temp_dir,z);
      if(finder=_findfirst(file,&fileinfo)!=-1){
        numfonts++;
        fonts[100-z]=z;
        fontoff[100-z]=0;
        _findclose(finder);
      }
    }
  }
  sprintf(file,"%s*.000",temp_dir);
  if(finder=_findfirst(file,&fileinfo)!=-1){
    strcpy(game_name,fileinfo.name);
    for(x=strlen(game_name);(x>0)&&(game_name[x]!='.');x--) game_name[x]=0;
    game_name[x]=0;
    version=MONKEY2;
    pre[0]='0';
    pre[1]='0';
    _findclose(finder);
  }
  sprintf(file,"%s%s*.SM0",temp_dir,game_name);
  if(finder=_findfirst(file,&fileinfo)!=-1){
    strcpy(game_name,strrchr(fileinfo.name,'\\'));
    for(x=strlen(game_name);(x>0)&&(game_name[x]!='.');x--) game_name[x]=0;
    version=SAMNMAX;
    pre[0]='S';
    pre[1]='M';
    _findclose(finder);
  }
  numdigis=0;
  sprintf(file,"%sMONSTER.SOU",temp_dir);
  if(finder=_findfirst(file,&fileinfo)!=-1){
    old_crypt=lucas_crypt;
    lucas_crypt=0;
    fin=fopen(file,"rb");
    lucas_read_head(fin,head,4);
    size=flip(lucas_read_long(fin));
    while(!feof(fin)){
      if(strcmp("VCTL",head)==0){
        fseek(fin,size-8,SEEK_CUR);
        digioff[numdigis++]=ftell(fin);
        fseek(fin,0x1B,SEEK_CUR);
        size=lucas_read_int(fin);
        fsize=lucas_read_char(fin);
        fsize<<=16;
        size|=fsize;
        fseek(fin,size+1,SEEK_CUR);
      }
      lucas_read_head(fin,head,4);
      size=flip(lucas_read_long(fin));
    }
    fclose(fin);
    lucas_crypt=old_crypt;
    _findclose(finder);
  }
  if(version==0){
    alert("Unknown file version!",NULL,NULL,"Ok",NULL,0,0);
    version=oldversion;
    return(D_REDRAW);
  }
  if((version>0)&&(version<=LOOM_INDY_OLD))
    lucas_crypt=0xff;
  else if(version==INDY_256)
    lucas_crypt=0x00;
  else if(version>=MONK_EGA)
    lucas_crypt=0x69;
  old_crypt=lucas_crypt;
  strcpy(game_dir,temp_dir);
  reset_screen();
  reset_menu();
  resource_current=-1;
  main_screen[DLG_LIST].d1=0;
  main_screen[DLG_LIST].d2=0;
  switch(version){
    case MM_OLD:
    case ZAK_OLD:
      load_table=&load_table_00;
      load_room=&load_room_00;
    case MM_ZAK_NEW:
      load_table=&load_table_00;
      load_room=&load_room_00;
    break;
    case LOOM_INDY_OLD:
      load_table=&load_table_00;
      load_room=&load_room_00;
    break;
    case INDY_256:
      load_table=&load_table_000;
      load_room=&load_room_000;
    break;
    case MONK_EGA:
      load_table=&load_table_000;
      load_room=&load_room_000;
    break;
    case MONK_VGA:
      load_table=&load_table_000;
      load_room=&load_room_000;
    break;
    case MONKEY2:
    case SAMNMAX:
      load_table=&load_table_new;
      load_room=&load_room_new;
    break;
  }
  load_table();
  resource_count=0;
  for(z=1;z<numrooms;z++){
    if(((rooms[z]>0)||(version==INDY_256))&&(rooms[z]<0x40)){
      if(check_room(z)){
        if(version<MONK_EGA)
          sprintf(resource_list[resource_count].name,"Room    #%.3u on Disk #00%c",z,rooms[z]);
        else 
          sprintf(resource_list[resource_count].name,"Room    #%.3u on Disk #%.3u %-9s",z,rooms[z],roomnames[z]);
        resource_list[resource_count].type=ROOM;
        resource_list[resource_count].number=z;
        resource_list[resource_count].room=z;
        resource_list[resource_count].offset=0;
        resource_count++;
      }
    }
  }
  for(z=1;z<numcostumes;z++){
    if((costumes[z]!=0xff)&&(costumes[z]!=0x00)){
      sprintf(resource_list[resource_count].name,"Costume #%.3u in Room #%.3u",z,costumes[z]);
      resource_list[resource_count].type=COSTUME;
      resource_list[resource_count].number=z;
      resource_list[resource_count].room=costumes[z];
      resource_list[resource_count].offset=costoff[z];
      resource_count++;
    }
  }
  for(z=1;z<numscripts;z++){
    if((scripts[z]!=0xff)&&(scripts[z]!=0x00)){
      sprintf(resource_list[resource_count].name,"Script  #%.3u in Room #%.3u",z,scripts[z]);
      resource_list[resource_count].type=SCRIPT;
      resource_list[resource_count].number=z;
      resource_list[resource_count].room=scripts[z];
      resource_list[resource_count].offset=scroff[z];
      resource_count++;
    }
  }
  for(z=1;z<numsounds;z++){
    if((sounds[z]!=0xff)&&(sounds[z]!=0x00)){
      sprintf(resource_list[resource_count].name,"Sound   #%.3u in Room #%.3u",z,sounds[z]);
      resource_list[resource_count].type=SOUND;
      resource_list[resource_count].number=z;
      resource_list[resource_count].room=sounds[z];
      resource_list[resource_count].offset=sndoff[z];
      resource_count++;
    }
  }
  for(z=0;z<numfonts;z++){
    if((fonts[z]!=0xff)&&(fonts[z]!=0x00)){
      sprintf(resource_list[resource_count].name,"Font    #%.3u in Room #%.3u",z,fonts[z]);
      resource_list[resource_count].type=FONT;
      resource_list[resource_count].number=z;
      resource_list[resource_count].room=fonts[z];
      resource_list[resource_count].offset=fontoff[z];
      resource_count++;
    }
  }
  for(z=0;z<numdigis;z++){
      sprintf(resource_list[resource_count].name,"Digital Sound #%.3u",z+1);
      resource_list[resource_count].type=DIGI;
      resource_list[resource_count].number=z;
      resource_list[resource_count].room=0;
      resource_list[resource_count].offset=digioff[z];
      resource_count++;    
  }
  return(D_REDRAW);
}

int save_background(){
  sprintf(temp_dir,"%sROOM%.3u.PCX",game_dir,resource_list[main_screen[DLG_LIST].d1].number);
  if(file_select("Enter file name:",temp_dir,"PCX")){
    pcx=create_sub_bitmap(background,0,0,picwidth,picheight);
    save_pcx(temp_dir,pcx,vga_pal);
    destroy_bitmap(pcx);
  }
  return(D_REDRAW);
}

int save_object(){
  sprintf(temp_dir,"%sOBJ%.3u.PCX",game_dir,objs[main_screen[DLG_OBJLIST].d1].number);
  if(file_select("Enter file name:",temp_dir,"PCX")){
    pcx=create_sub_bitmap(objpict,0,0,objs[main_screen[DLG_OBJLIST].d1].width,objs[main_screen[DLG_OBJLIST].d1].height);
    save_pcx(temp_dir,pcx,vga_pal);
    destroy_bitmap(pcx);
  }
  return(D_REDRAW);
}

void fixtwovar(DIALOG *d){
  int x;
  for(x=1;x<=4;x+=2){
    d[x].w=text_length(font,d[x].dp);
    d[x].h=text_height(font);
    d[x+1].w=2*text_length(font,d[x+1].dp);
    d[x+1].h=text_height(font);
  }
  for(x=1;x<=4;x+=2){
    d[x].x=(d[0].w/2)-(d[x].w+d[x+1].w+16)/2;
    d[x].y=(x-1)*text_height(font)+(d[0].h/2)-(d[x].h+d[x+1].h);
  }
  for(x=2;x<=4;x+=2){
    d[x].x=d[x-1].x+d[x-1].w+16;
    d[x].y=d[x-1].y;
  }
  d[5].w=text_length(font,d[5].dp)+4;
  d[5].h=text_height(font);
  d[5].x=d[0].w/2-d[5].w/2;
  d[5].y=d[0].h-d[5].h-8;

}

int main(int argc, char *argv[]){
  allegro_init();
  install_keyboard();
  install_timer();
  install_mouse();
  install_sound(-1, -1, argv[0]);
  set_color_depth(16);
  set_gfx_mode(GFX_AUTODETECT, 800, 600, 0, 0);
  data=load_datafile("scumm16.dat");
  if(cd_init()<0){
    alert("CD Audio error!",NULL,NULL,"OK",NULL,0,0);
  }
  if(!data){
    alert("SCUMM16.DAT","not found!","","OK",NULL,0,0);
    exit(1);
  }
  font=data[UFONT].dat;
  main_screen[DLG_INFOTEXT].h=text_height(font);
  main_screen[DLG_INFOBACK].h=text_height(font)+6;
  set_dialog_color(mouse_speed,0,makecol(255,255,255));
  set_dialog_color(room_col,0,makecol(255,255,255));
  fixtwovar(mouse_speed);
  fixtwovar(room_col);
  centre_dialog(mouse_speed);
  centre_dialog(room_col);
  gui_fg_color=0;
  gui_bg_color=makecol(255,255,255);
  main_screen[DLG_CLEAR].bg=makecol(127,127,127);
  main_screen[DLG_MENU].bg=makecol(0,0,0);
  main_screen[DLG_GRAPHIC].bg=makecol(127,127,127);
  main_screen[DLG_SLIDER].bg=makecol(127,127,127);
  main_screen[DLG_LIST].bg=makecol(255,255,255);
  main_screen[DLG_OBJECT].bg=makecol(127,127,127);
  main_screen[DLG_OBJLIST].bg=makecol(255,255,255);
  main_screen[DLG_INFOBACK].bg=makecol(255,255,255);
  main_screen[DLG_INFOTEXT].bg=makecol(255,255,255);
  main_screen[DLG_SCRIPT].bg=makecol(255,255,255);
  background=create_bitmap(MAX_BACK,main_screen[DLG_GRAPHIC].h);
  clear_to_color(background,main_screen[DLG_GRAPHIC].bg);
  main_screen[DLG_GRAPHIC].dp=background;
  objpict=create_bitmap(main_screen[DLG_OBJECT].w,main_screen[DLG_OBJECT].h);
  clear_to_color(objpict,main_screen[DLG_OBJECT].bg);
  main_screen[DLG_OBJECT].dp=objpict;
  show_mouse(screen);
  player = init_dialog(main_screen, -1);
  while (update_dialog(player));
  shutdown_dialog(player);
  destroy_bitmap(background);
  destroy_bitmap(objpict);
  unload_datafile(data);
  allegro_exit();
  return(0);
}

END_OF_MAIN();
